/*
 * uart.c
 *
 *  Created on: Feb 17, 2012
 *      Author: ksnieck
 */

// UART initialization and communication functions for MSP430F2616

#include <msp430.h>
#include <msp430x26x.h>
#include "uart.h"

// Using UCA0 for PC communication
// 115200 baud
// TX -> P3.4
// RX -> P3.5

void pc_uart_init(void) {

	  P3SEL |= 0x30;                             // P3.4,5 = USCI_A0 TXD/RXD
	  UCA0CTL1 |= UCSSEL_2;                     // SMCLK

	  //UCA0BR0 = 8;                              // 1MHz 115200
	  //UCA0BR1 = 0;                              // 1MHz 115200
	  //UCA0MCTL = UCBRS2 + UCBRS0;               // Modulation UCBRSx = 5

	  UCA0BR0 = 138;                          // 16MHz 115200
	  UCA0BR1 = 0;                            // 16MHz 115200
	  UCA0MCTL = UCBRS2 + UCBRS1 + UCBRS0;    // Modulation UCBRSx = 7

	  UCA0CTL1 &= ~UCSWRST;                     // **Initialize USCI state machine**
	  //IE2 |= UCA0RXIE;                          // Enable USCI_A0 RX interrupt

	  //_enable_interrupts();						// Enable Interrupts
}

// RX Interrupt
/*#pragma vector=USCIAB0RX_VECTOR
__interrupt void USCI0RX_ISR(void)
{
  switch (UCA0RXBUF) {
  case 'm':
	  // Send ADC Measurements?
	  break;
  case '0':
  	  crazy_leds(); // DO SOMETHIN CRAZY MAN
  	  break;
  default:
	  // FUCK DA SHIT
	  break;
  }
}*/

void pc_uart_tx(char data) {
	// Transmit byte to PC
	while (!(IFG2&UCA0TXIFG));             // USCI_A0 TX buffer ready?
	UCA0TXBUF = data;
}

char pc_uart_rx() {
	// check for and return byte from PC
	// will not return until data is available

	while(!(IFG2&UCA0RXIFG));
	return UCA0RXBUF;
}

int uart_open(const char *path, unsigned flags, int llv_fd) {
	return 0;
}

int uart_close(int dev_fd) {
	return 0;
}

int uart_read(int dev_fd, char *buf, unsigned count) {
	return 0;
}

long uart_lseek(int dev_fd, long offset, int origin) {
	return 0;
}

int uart_unlink(const char *path) {
	return 0;
}


int uart_rename(const char *old_name, const char *new_name) {
	return 0;
}

int uart_write(int dev_fd, const char *buf, unsigned count) {

	int i;

	for (i = 0; i < count; i++)
		pc_uart_tx(buf[i]);

	return 0;
}



void crazy_leds(void) {
	char state;
	state = P4OUT;
	unsigned int i,j;
	for (j = 0; j < 8; j++) {
		P4OUT = 1 << j;
		for (i = 0; i < 50000; i++);
	}
	for (j = 7; j > 0; j--) {
		P4OUT = 1 << j;
		for (i = 0; i < 50000; i++);
	}
	P4OUT = state;
}








